package examples.hibernate;

import org.hibernate.Session;
import org.hibernate.SessionFactory;
import org.hibernate.Transaction;
import org.hibernate.criterion.Order;

import java.util.List;


import examples.hibernate.domain.*;

public class Example {
    public static void main(String args[]) throws Exception {
	SessionFactory factory = PersistenceUtil.getSessionFactory();
	Session session = factory.getCurrentSession();  // obtain/start unit of work
	Transaction tx = null;
	try {
	    tx = session.beginTransaction();            // start transaction

	    Airplane airplane = new Airplane("Air Force One", 21000, 60, 71);
	    session.save(airplane);
	    Passenger passenger = new Passenger("George W. Bush", "1");
	    airplane.addPassenger(passenger);
	    session.save(passenger);
            passenger = new Passenger("John Travolta", "2");
	    airplane.addPassenger(passenger);
	    session.save(passenger);
	    airplane = new Airplane("Jett Clipper Ella", 52163, 39, 40);
	    session.save(airplane);
	    airplane.addPassenger(passenger);
	    session.save(passenger);
	    tx.commit();                                // commit transaction & end unit of work
	} catch (RuntimeException ex) {
	    if (tx != null) tx.rollback();              // abort transaction
	    throw ex;
	}

	session = factory.getCurrentSession();  // obtain/start unit of work
	try {
	    tx = session.beginTransaction();            // start transaction
	    // read last airplane
	    List<Airplane> airplanes = (List<Airplane>) session.createCriteria(Airplane.class)
						.addOrder( Order.asc("name") )
		                                .list();

	    for (Airplane airplane : airplanes) {
	    	System.out.println(airplane);
	    }
	    tx.commit();                                // commit transaction & end unit of work
	} catch (RuntimeException ex) {
	    if (tx != null) tx.rollback();              // abort transaction
	    throw ex;
	}
    }
}
