package examples.hibernate.domain;

import javax.persistence.*;

@MappedSuperclass
public abstract class Aircraft {             // mapped class that won't be persisted
    /** 
     * Unique identifier.
     */
    @SuppressWarnings("unused")
    @Id @GeneratedValue(strategy=GenerationType.AUTO)
    private Long id;

    /**
     * Object version number.  
     * Necessary for the optimistic policy for concurrency control
     */
    @SuppressWarnings("unused")
    @Version
    private Long objVersion;    
    
    private String name;
    private long weight;

    protected Aircraft() { }
    
    protected Aircraft(String name, long weight) {
	setName(name);
	setWeight(weight);
    }
    
    public String getName() {
	return this.name;
    }

    public void setName(String name) {
	this.name = name;
    }

    public long getWeight() {
	return this.weight;
    }

    public void setWeight(long weight) {
	this.weight = weight;
    }

    public String toString() {
	StringBuilder sb = new StringBuilder("\t")
		.append(this.getClass().getSimpleName())
		.append(": ")
		.append(name)
		.append("\n\tWeight: ").append(weight).append("kg");
	return sb.toString();
    }

    
}